#line 1 "C:/Users/Pavel/Google /Projects/Logic/74HC595_TEST/595_TEST_V2/LCDv1.c"
#line 1 "c:/users/pavel/google /projects/logic/74hc595_test/595_test_v2/lcdv1.h"
#line 20 "c:/users/pavel/google /projects/logic/74hc595_test/595_test_v2/lcdv1.h"
void LCD_init(void);
void LCD_Write( unsigned char  Dat);
void LCD_Send_Cmd( unsigned char  CMD);
void lcd_set_position( unsigned char  row,  unsigned char  colum);
void lcd_write_data( unsigned char  dat);
void lcd_print_char( unsigned char  dat);
void lcd_print_string( unsigned char  * string);
void lcd_print_value( unsigned long  val);
void lcd_print_hex_value(long val);
void LCD_BackLight (unsigned char State);
#line 1 "c:/users/pavel/google /projects/logic/74hc595_test/595_test_v2/mc74hc595.h"
void MC74HC595_SendByte (unsigned char Byte);
void MC74HC595_SendData (unsigned char * Data);
#line 10 "C:/Users/Pavel/Google /Projects/Logic/74HC595_TEST/595_TEST_V2/LCDv1.c"
unsigned char SPI_DAT=0;

void LCD_init(void)
{
 Delay_ms(17);
 LCD_Write(0x30);
 Delay_ms(1);
 LCD_Write(0x30);
 Delay_ms(1);
 LCD_Write(0x30);
 Delay_ms(1);
 LCD_Write(0x20);

 LCD_Send_Cmd(0x28);
 LCD_Send_Cmd(0x10);
 LCD_Send_Cmd(0x01);
 LCD_Send_Cmd(0x0F);

 LCD_Send_Cmd( 0x0C );
 LCD_Send_Cmd( 0x01 );
 Delay_ms(10);
}

void LCD_Write( unsigned char  Dat)
{
 SPI_DAT&=( (1<<2) | (1<<1) );
 SPI_DAT|=(Dat& 0xF0 )| (1<<3) ;
 MC74HC595_SendByte(SPI_DAT);
 Delay_us(5);
 SPI_DAT&=~ (1<<3) ;
 MC74HC595_SendByte(SPI_DAT);
 Delay_us(5);
}
void LCD_Send_Cmd( unsigned char  CMD)
{
 Delay_ms(5);
 SPI_DAT&=~ (1<<2) ;
 LCD_Write((CMD&0xF0));
 LCD_Write(((CMD&0x0F)<<4));
}

void lcd_set_position( unsigned char  row,  unsigned char  colum)
{
  unsigned char  position = 0x80;
 if (row > 0) { position |= 0x40;}
 LCD_Send_Cmd(position | colum);
}

void lcd_write_data( unsigned char  dat)
{
 Delay_us(50);
 SPI_DAT|= (1<<2) ;
 LCD_Write((dat&0xF0));
 LCD_Write(((dat&0x0F)<<4));
}

void lcd_print_char( unsigned char  dat)
{
 if (dat == '\n')
 {LCD_Send_Cmd(0x80 | 0x40);} else {lcd_write_data(dat);}
}

void lcd_print_string( unsigned char  * string)
{
 while (*string != 0x00){ lcd_print_char(*string++);}
}

void lcd_print_value(unsigned long val)
{
  unsigned char  buffer[10] = {0};
  unsigned char * head = buffer;
  unsigned char  cnt=0;
 if (val!=0)
 {
 while( val )
 {

 val /= 10;
 cnt++;
 }
 while (cnt!=0){ cnt--; lcd_print_char(buffer[cnt]); }
 }
 else
 {
 lcd_print_char('0');
 }
}

void lcd_print_hex_value(long val)
{
 char buffer[10] = {0};
 char * head = buffer;
 char cnt=0;
 lcd_print_char('0');
 lcd_print_char('x');
 if (val<=9) lcd_print_char('0');
 if (val!=0)
 {
 while( val )
 {

 val=val>>4;
 cnt++;
 }
 while (cnt!=0){ cnt--; lcd_print_char(buffer[cnt]); }
 }
 else
 {
 lcd_print_char('0');
 }
 lcd_print_char(' ');
}

void LCD_BackLight (unsigned char State)
{
 if (State) SPI_DAT|= (1<<1) ;
 else SPI_DAT&=~ (1<<1) ;
}
